commit abcc570a7126ed6aecf0985e751e5b7c1b594fe6
Author: jklowden <jklowden>
Date:   Thu Jun 12 03:52:04 2008 +0000

    (added)

diff --git a/ChangeLog b/ChangeLog
index 7f6c7bb..cde84f2 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Wed Jun 11 23:26:34 EDT 2008	JK Lowden <jklowden@freetds.org>
+	* src/odbc/unittests/Makefile.am
+	* src/odbc/unittests/cursor7.c (added)
+	- test for fetching overlapping batches
+
 Wed Jun 11 23:07:29 EDT 2008	JK Lowden <jklowden@freetds.org>
 	* src/odbc/odbc.c src/odbc/unittests/getdata.c
 	- Applied patch from Suren A. Chilingaryan cf. 
@@ -343,4 +348,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2534 2008/06/12 03:10:16 jklowden Exp $
+$Id: ChangeLog,v 1.2535 2008/06/12 03:52:04 jklowden Exp $
diff --git a/src/odbc/unittests/Makefile.am b/src/odbc/unittests/Makefile.am
index ad4ee0f..3496168 100644
--- a/src/odbc/unittests/Makefile.am
+++ b/src/odbc/unittests/Makefile.am
@@ -1,4 +1,4 @@
-# $Id: Makefile.am,v 1.75 2008/06/05 16:12:19 freddy77 Exp $
+# $Id: Makefile.am,v 1.76 2008/06/12 03:52:05 jklowden Exp $
 TESTS		=	\
 			t0001$(EXEEXT) t0002$(EXEEXT) t0003$(EXEEXT)\
 			t0004$(EXEEXT) connect$(EXEEXT) print$(EXEEXT)\
@@ -22,7 +22,7 @@ TESTS		=	\
 			cursor3$(EXEEXT) cursor4$(EXEEXT) cursor5$(EXEEXT) \
 			attributes$(EXEEXT) hidden$(EXEEXT) blob1$(EXEEXT) \
 			cancel$(EXEEXT) wchar$(EXEEXT) rowset$(EXEEXT) transaction2$(EXEEXT) \
-			cursor6$(EXEEXT)
+			cursor6$(EXEEXT) cursor7$(EXEEXT)
 
 check_PROGRAMS	=	$(TESTS)
 
@@ -86,6 +86,7 @@ cancel_SOURCES = cancel.c common.c common.h
 wchar_SOURCES = wchar.c common.c common.h
 transaction2_SOURCES = transaction2.c common.c common.h
 cursor6_SOURCES	= cursor6.c common.c common.h
+cursor7_SOURCES	= cursor7.c common.c common.h
 
 AM_CPPFLAGS	=	-I$(top_srcdir)/include $(ODBC_INC) -DFREETDS_SRCDIR=\"$(srcdir)\"
 if MINGW32
diff --git a/src/odbc/unittests/cursor7.c b/src/odbc/unittests/cursor7.c
new file mode 100644
index 0000000..f36a464
--- /dev/null
+++ b/src/odbc/unittests/cursor7.c
@@ -0,0 +1,99 @@
+#include "common.h"
+
+/* Test SQLFetchScroll with no bound columns */
+
+static char software_version[] = "$Id: cursor7.c,v 1.1 2008/06/12 03:52:05 jklowden Exp $";
+static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
+
+static void
+Test(void)
+{
+	enum { ROWS=5 };
+	struct data_t {
+		SQLINTEGER i;
+		SQLLEN ind_i;
+		char c[20];
+		SQLLEN ind_c;
+	} data[ROWS];
+	SQLUSMALLINT statuses[ROWS];
+	SQLULEN num_row;
+
+	int i;
+	SQLRETURN ErrCode;
+
+	ResetStatement();
+
+	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_CONCURRENCY, int2ptr(SQL_CONCUR_READ_ONLY), 0));
+	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_CURSOR_TYPE, int2ptr(SQL_CURSOR_STATIC), 0));
+
+	CHK(SQLPrepare, (Statement, (SQLCHAR *) "SELECT c, i FROM #cursor7_test", SQL_NTS));
+	CHK(SQLExecute, (Statement));
+	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_ROW_BIND_TYPE, int2ptr(sizeof(data[0])), 0));
+	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_ROW_ARRAY_SIZE, int2ptr(ROWS), 0));
+	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_ROW_STATUS_PTR, statuses, 0));
+	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_ROWS_FETCHED_PTR, &num_row, 0));
+
+	CHK(SQLBindCol, (Statement, 1, SQL_C_CHAR, &data[0].c, sizeof(data[0].c), &data[0].ind_c));
+	CHK(SQLBindCol, (Statement, 2, SQL_C_LONG, &data[0].i, sizeof(data[0].i), &data[0].ind_i));
+
+	/* Read records from last to first */
+	printf("\n\nReading records from last to first:\n");
+	ErrCode = SQLFetchScroll(Statement, SQL_FETCH_LAST, -ROWS);
+	while ((ErrCode == SQL_SUCCESS) || (ErrCode == SQL_SUCCESS_WITH_INFO)) {
+		/* Print this set of rows */
+		for (i = ROWS - 1; i >= 0; i--) {
+			if (statuses[i] != SQL_ROW_NOROW)
+				printf("\t %d, %s\n", (int) data[i].i, data[i].c);
+		}
+
+		/* Read next rowset */
+		ErrCode = SQLFetchScroll(Statement, SQL_FETCH_RELATIVE, -ROWS);
+	}
+	printf("\nRecords 5, 4 and 3 are returned twice!!\n\n");
+}
+
+static void
+Init(void)
+{
+	int i;
+	char sql[128];
+
+	printf("\n\nCreating table #cursor7_test with 12 records.\n");
+
+	Command(Statement, "\tCREATE TABLE #cursor7_test (i INT, c VARCHAR(20))");
+	for (i = 1; i <= 12; ++i) {
+		sprintf(sql, "\tINSERT INTO #cursor7_test(i,c) VALUES(%d, 'a%db%dc%d')", i, i, i, i);
+		Command(Statement, sql);
+	}
+
+}
+
+int
+main(int argc, char *argv[])
+{
+	unsigned char sqlstate[6], msg[256];
+	SQLRETURN retcode;
+
+	use_odbc_version3 = 1;
+	Connect();
+
+	retcode = SQLSetConnectAttr(Connection, SQL_ATTR_CURSOR_TYPE, (SQLPOINTER) SQL_CURSOR_DYNAMIC, SQL_IS_INTEGER);
+	if (retcode != SQL_SUCCESS) {
+		CHK(SQLGetDiagRec, (SQL_HANDLE_DBC, Connection, 1, sqlstate, NULL, (SQLCHAR *) msg, sizeof(msg), NULL));
+		sqlstate[5] = 0;
+		if (strcmp((const char *) sqlstate, "S1092") == 0) {
+			printf("Your connection seems to not support cursors, probably you are using wrong protocol version or Sybase\n");
+			Disconnect();
+			exit(0);
+		}
+		ODBC_REPORT_ERROR("SQLSetConnectAttr");
+	}
+
+	Init();
+
+	Test();
+
+	Disconnect();
+
+	return 0;
+}

